#include <stdlib.h>
#include <stdio.h>

class Record {
	public:
		void printThis (void)
			{	printf ("Hello\n"); }
};

class ListNode {
	private:
		long id;				// Index of this record
		Record *thisOne;
		ListNode *nextOne;
	public:
		ListNode (long index, Record *obj, ListNode *next)
			{	id = index;
				thisOne = obj;
				nextOne = next;
			}
		~ListNode (void)
			{	delete nextOne;
				delete thisOne;
			}
		Record *FindRecord (long);
		void DumpList (void);
};

Record *ListNode::FindRecord (long index)
{
	if (id == index)
		return thisOne;
	if (nextOne != NULL)
		return nextOne->FindRecord(index);
	return NULL;
}

void ListNode::DumpList (void)
{
	printf ("%ld: ", id);
	thisOne->printThis();
	if (nextOne != NULL)
		nextOne->DumpList();
}

class SparseArray {
	private:
		ListNode *sparseList;		// Linked list of Objects
	
	public:
		SparseArray (void)
			{	sparseList = NULL; }
		~SparseArray (void)
			{	delete sparseList; }
		Record *operator [](long);
		void AddRecord (Record *r, long index)
			{	sparseList = new ListNode (index, r, sparseList); }
		void DumpArray (void)
			{	if (sparseList != NULL)
					sparseList->DumpList();
			}
};

Record *SparseArray::operator [] (long index)
{
	if (sparseList != NULL)
		return sparseList->FindRecord (index);
	return NULL;
}

main ()
{
	SparseArray s;
	long index;
	Record *r;
	
	for (index = 0; index < 1000000; index += 100000)
		s.AddRecord (new Record, index);
	
	s.DumpArray();
	
	printf ("Printing index number 500000: ");
	r = s[500000];
	if (r != NULL)
		r->printThis();
}