#include <stdlib.h>
#include <stdio.h>

class NewNew {
	private:
		static void *freeList;			// A global pointer to free space list
	
	public:
		void *operator new (size_t);	// Allocate from free list if non-empty
		void operator delete (void *);	// Place on free list
		
		friend long freeCount (void);	// Return size of free list
	};

void *NewNew::freeList = NULL;

void *NewNew::operator new (size_t bytes)
{
	if (freeList != NULL) {
		void *newSpace;
	
		newSpace = (NewNew *)freeList;
		freeList = *(void **)freeList;
		return newSpace;
		}
	return (void *)malloc (bytes);
}

void NewNew::operator delete (void *obj)
{
	*(void **)obj = freeList;
	freeList = obj;
}

long freeCount (void)
{
	void *p;
	long count;
	
	for (count = 0, p = NewNew::freeList; p != NULL; count++, p = *(void **)p) ;
	return count;
}

main ()
{
	NewNew *obj[10];
	int i;
	
	for (i = 0; i < 10; i++)
		obj[i] = new NewNew;
	printf ("Free list size after allocation == %ld\n", freeCount());

	for (i = 0; i < 10; i++) {
		delete obj[i];
		}
	printf ("Free list size after destruction == %ld\n", freeCount());
		
	for (i = 0; i < 5; i++)
		obj[i] = new NewNew;
	printf ("Free list size after reallocation == %ld\n", freeCount());
}